Index: /java/main/src/main/java/com/framsticks/model/f0/SchemaBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/f0/SchemaBuilder.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/model/f0/SchemaBuilder.java	(revision 90)
@@ -0,0 +1,49 @@
+package com.framsticks.model.f0;
+
+import java.util.Arrays;
+import java.util.List;
+
+import com.framsticks.model.ModelPackage;
+import com.framsticks.params.FramsClassBuilder;
+import com.framsticks.params.GroupBuilder;
+import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.parsers.XmlLoader;
+import com.framsticks.util.AutoBuilder;
+import com.framsticks.util.ResourceBuilder;
+
+@FramsClassAnnotation
+public class SchemaBuilder extends ResourceBuilder<Schema> implements AutoBuilder {
+
+	@Override
+	public Schema finish() {
+
+		if (stream == null) {
+			stream(Schema.getDefaultDefinitionAsStream());
+		}
+
+		XmlLoader xmlLoader = new XmlLoader();
+		xmlLoader.setUseLowerCase(true);
+		xmlLoader.getRegistry()
+			.registerAndBuild(Schema.class)
+			.registerAndBuild(FramsClassBuilder.class)
+			.registerAndBuild(NeuroClassBuilder.class)
+			.registerAndBuild(ParamBuilder.class)
+			.registerAndBuild(NeuroParamBuilder.class)
+			.registerAndBuild(GroupBuilder.class)
+			;
+
+		new ModelPackage().register(xmlLoader.getRegistry());
+
+		Schema schema = xmlLoader.load(Schema.class, stream);
+		new ModelPackage().register(schema.getRegistry());
+		return schema;
+	}
+
+	@Override
+	public List<Object> autoFinish() {
+		Schema result = finish();
+		return Arrays.asList((Object) result);
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 90)
@@ -2,4 +2,6 @@
 
 import java.util.Collection;
+
+import com.framsticks.params.types.ProcedureParam;
 
 
@@ -20,10 +22,9 @@
 	String getId();
 
-	Param getGroupMember(int gi, int n);
-
 	int getParamCount();
 
-	// void call(int i, Object args, Object ret);
-	// TODO: as for now it's not necessary to implement this method
+	Object call(String id, Object[] arguments);
+
+	Object call(ProcedureParam param, Object[] arguments);
 
 	<T> T get(int i, Class<T> type);
Index: /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 90)
@@ -32,5 +32,5 @@
 	public Param getParam(int i) {
 		//TODO listAccessParam
-		return Param.build().id(Integer.toString(i)).name(elementAccess.getId()).type("o " + elementAccess.getId()).finish();
+		return Param.build().id(Integer.toString(i)).forAccess(elementAccess).finish();
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 90)
@@ -4,4 +4,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Containers;
 // import com.framsticks.util.FramsticksException;
 
@@ -51,6 +52,7 @@
 	// protected Map<String, Integer> paramIdMap = new HashMap<String, Integer>();
 
-	public Collection<Param> getParamEntries() {
-		return paramList;
+	@ParamAnnotation(id = "props", name = "props")
+	public List<Param> getParamEntries() {
+		return Collections.unmodifiableList(paramList);
 	}
 
@@ -60,17 +62,9 @@
 		this.name = builder.getName();
 		this.description = builder.getDescription();
-		this.groups = builder.groups;
+		this.groups = Containers.build(builder.groupBuilders);
 		this.paramList = builder.params;
 
 		for (Param param : paramList) {
 			paramEntryMap.put(param.getId(), param);
-			try {
-				Group group = groups.get(param.getGroup());
-				if (group != null) {
-					group.addProperty(param);
-				}
-			} catch (IndexOutOfBoundsException ignored) {
-
-			}
 		}
 
@@ -88,33 +82,37 @@
 	}
 
-	/**
-	 * Gets the group member.
-	 *
-	 * @param gi
-	 *            the offset of group
-	 * @param pi
-	 *            the offset of member within a group
-	 * @return the pi-th member of group gi
-	 */
-	public Param getGroupMember(int gi, int pi) {
-		if (gi < 0 || pi < 0 || gi >= groups.size()) {
-			return null;
-		}
-		Group group = groups.get(gi);
-		return (group != null ? group.getProperty(pi) : null);
+	public Group getGroup(int groupNumber) {
+		return Containers.getFromList(groups, groupNumber, "group", this);
 	}
 
-	/**
-	 * Gets the group name.
-	 *
-	 * @param gi
-	 *            the offset of group
-	 * @return the group name
-	 */
-	public String getGroupName(int gi) {
-		if (gi < 0 || gi >= groups.size())
-			return null;
-		return groups.get(gi).name;
-	}
+	// /**
+	//  * Gets the group member.
+	//  *
+	//  * @param gi
+	//  *            the offset of group
+	//  * @param pi
+	//  *            the offset of member within a group
+	//  * @return the pi-th member of group gi
+	//  */
+	// public Param getGroupMember(int gi, int pi) {
+	// 	if (gi < 0 || pi < 0 || gi >= groups.size()) {
+	// 		return null;
+	// 	}
+	// 	Group group = groups.get(gi);
+	// 	return (group != null ? group.getProperty(pi) : null);
+	// }
+
+	// /**
+	//  * Gets the group name.
+	//  *
+	//  * @param gi
+	//  *            the offset of group
+	//  * @return the group name
+	//  */
+	// public String getGroupName(int gi) {
+	// 	if (gi < 0 || gi >= groups.size())
+	// 		return null;
+	// 	return groups.get(gi).name;
+	// }
 
 	@ParamAnnotation
Index: /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 90)
@@ -22,5 +22,5 @@
 import com.framsticks.parsers.Loaders;
 import com.framsticks.util.Builder;
-import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Containers;
 import com.framsticks.util.lang.Strings;
 
@@ -38,5 +38,6 @@
 	}
 
-	public static String getParamTypeForNativeType(Type type) {
+	public static ParamBuilder induceParamType(ParamBuilder builder, Type type) {
+
 		if (type instanceof ParameterizedType) {
 			ParameterizedType p = (ParameterizedType) type;
@@ -52,5 +53,5 @@
 			}
 			if (!(containedType instanceof Class)) {
-				return null;
+				return builder;
 			}
 			Class<?> containedClass = (Class<?>) containedType;
@@ -60,5 +61,5 @@
 			if (fca == null) {
 				log.error("the class is not annotated: " + containedClass);
-				return null;
+				return builder;
 			}
 			b.append(getName(fca, containedClass));
@@ -67,5 +68,6 @@
 			}
 
-			return b.toString();
+			builder.type(b.toString());
+			return builder;
 		}
 
@@ -87,23 +89,50 @@
 			// }
 			if (cl.equals(Integer.class) || cl.equals(int.class)) {
-				return "d";
+				builder.type("d");
+				return builder;
 			}
 			if (cl.equals(String.class)) {
-				return "s";
+				builder.type("s");
+				return builder;
 			}
 			if (cl.equals(Double.class) || cl.equals(double.class)) {
-				return "f";
+				builder.type("f");
+				return builder;
 			}
 			if (cl.equals(Boolean.class) || cl.equals(boolean.class)) {
-				return "d 0 1";
+				builder.type( "d 0 1");
+				return builder;
 			}
 			if (cl.equals(Object.class)) {
-				return "x";
-			}
-
-			return "o " + ((Class<?>) type).getCanonicalName();
+				builder.type("x");
+				return builder;
+			}
+
+			// builder.type("o " + (cl).getCanonicalName());
+			builder.type("o " + cl.getSimpleName());
+			builder.fillStorageType(cl);
+			return builder;
 		}
 
 		throw new ConstructionException().msg("failed to find framsticks for native type").arg("type", type);
+	}
+
+
+	public static ParamBuilder induceParamType(ParamBuilder builder, ParamCandidate candidate) {
+		Method method = candidate.getCaller();
+		if (method == null) {
+			return induceParamType(builder, candidate.getType());
+		}
+
+		builder.resultType(induceParamType(Param.build(), method.getGenericReturnType()).finish(ValueParam.class));
+
+		List<ValueParam> arguments = new ArrayList<>();
+		int number = 0;
+		for (Type arg : method.getGenericParameterTypes()) {
+			arguments.add(induceParamType(Param.build(), arg).idAndName("arg" + (number++)).finish(ValueParam.class));
+		}
+		builder.argumentsType(arguments);
+
+		return builder;
 	}
 
@@ -183,12 +212,31 @@
 		name(getName(fca, javaClass));
 
-		Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(javaClass);
-
-		for (ParamCandidate pc : candidates.values()) {
-			String type = getParamTypeForNativeType(pc.getType());
-			if (type == null) {
-				throw new FramsticksException().msg("failed to find type for param candidate").arg("candidate", pc);
-			}
-			param(Param.build().id(pc.getId()).name(pc.getName()).type(type).flags(pc.getFlags()));
+		for (ParamCandidate pc : ParamCandidate.getAllCandidates(javaClass).getOrder()) {
+			ParamBuilder builder = Param.build().id(pc.getId()).name(pc.getName()).flags(pc.getFlags());
+
+			induceParamType(builder, pc);
+
+			for (ParamAnnotation pa : pc.getAnnotations()) {
+				if (!"".equals(pa.def())) {
+					builder.def(pa.def());
+				}
+				if (!"".equals(pa.help())) {
+					builder.help(pa.help());
+				}
+				if (!"".equals(pa.min())) {
+					builder.min(pa.min());
+				}
+				if (!"".equals(pa.max())) {
+					builder.max(pa.max());
+				}
+				builder.extra(pa.extra());
+				if (!"".equals(pa.stringType())) {
+					builder.type(pa.stringType());
+				}
+				if (!pa.paramType().equals(Param.class)) {
+					builder.type(pa.paramType());
+				}
+			}
+			param(builder);
 		}
 
@@ -209,5 +257,5 @@
 	protected final List<Param> params = new LinkedList<>();
 
-	protected List<Group> groups = new ArrayList<Group>();
+	protected List<GroupBuilder> groupBuilders = new ArrayList<GroupBuilder>();
 
 	@ParamAnnotation
@@ -242,22 +290,20 @@
 	}
 
-	public FramsClassBuilder append(Param param) {
-		params.add(param);
-		return this;
-	}
-
 	@AutoAppendAnnotation
 	public FramsClassBuilder param(ParamBuilder builder) {
-		return append(builder.finish());
+		Param param = builder.finish();
+
+		Integer group = param.getGroup();
+		if (group != null) {
+			Containers.getFromList(groupBuilders, group, "group", this).addParam(param);
+		}
+
+		params.add(param);
+		return this;
 	}
 
 	@AutoAppendAnnotation
 	public FramsClassBuilder group(GroupBuilder builder) {
-		return group(builder.finish());
-	}
-
-	@AutoAppendAnnotation
-	public FramsClassBuilder group(Group group) {
-		groups.add(group);
+		groupBuilders.add(builder);
 		return this;
 	}
@@ -288,10 +334,7 @@
 
 	public FramsClassBuilder group(String group) {
-		return group(new Group(group));
-	}
-
-	public ParamBuilder param(String id) {
-		return new ParamBuilder(this).id(id);
-	}
+		return group(new GroupBuilder().name(group));
+	}
+
 
 }
Index: /java/main/src/main/java/com/framsticks/params/Group.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Group.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/Group.java	(revision 90)
@@ -1,9 +1,11 @@
 package com.framsticks.params;
 
-import java.util.ArrayList;
 import java.util.List;
+
+import javax.annotation.concurrent.Immutable;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.lang.Containers;
 
 /**
@@ -11,25 +13,18 @@
  */
 @FramsClassAnnotation
+@Immutable
 public class Group {
 
 	@ParamAnnotation
-	protected String name;
+	protected final String name;
 
 	/**
 	 * Group members.
 	 */
-	List<Param> params = new ArrayList<Param>();
+	protected final List<Param> params;
 
-	public Group(String name) {
-		this.name = name;
-	}
-
-	/**
-	 * Adds new group member.
-	 *
-	 * @param p the new group member
-	 */
-	void addProperty(Param p) {
-		params.add(p);
+	public Group(GroupBuilder builder) {
+		this.name = builder.getName();
+		this.params = builder.getParams();
 	}
 
@@ -40,13 +35,11 @@
 	 * @return the property
 	 */
-	Param getProperty(int i) {
-		if (i < 0 || i >= params.size())
-			return null;
-		return params.get(i);
+	public Param getParam(int number) {
+		return Containers.getFromList(params, number, "param", this);
 	}
 
 	@Override
 	public String toString() {
-		return name;
+		return "group" + name;
 	}
 
@@ -59,3 +52,7 @@
 	}
 
+	public int getCount() {
+		return params.size();
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/GroupBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/GroupBuilder.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/GroupBuilder.java	(revision 90)
@@ -1,12 +1,18 @@
 package com.framsticks.params;
+
+import java.util.ArrayList;
+import java.util.List;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.Builder;
 
 @FramsClassAnnotation(id = "group", name = "group")
-public class GroupBuilder {
+public class GroupBuilder implements Builder<Group> {
 
 	@ParamAnnotation
 	protected String name;
+
+	protected final List<Param> params = new ArrayList<Param>();
 
 	public GroupBuilder() {
@@ -19,6 +25,24 @@
 	}
 
+	/**
+	 * @return the name
+	 */
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @return the params
+	 */
+	public List<Param> getParams() {
+		return params;
+	}
+
 	public Group finish() {
-		return new Group(name);
+		return new Group(this);
+	}
+
+	public void addParam(Param param) {
+		params.add(param);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/InvalidOperationException.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/InvalidOperationException.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/params/InvalidOperationException.java	(revision 90)
@@ -0,0 +1,8 @@
+package com.framsticks.params;
+
+import com.framsticks.util.FramsticksException;
+
+@SuppressWarnings("serial")
+public class InvalidOperationException extends FramsticksException {
+
+}
Index: /java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 90)
@@ -4,4 +4,6 @@
 
 import static com.framsticks.util.lang.Containers.filterInstanceof;
+
+import com.framsticks.params.types.ProcedureParam;
 
 /**
@@ -16,8 +18,8 @@
 	}
 
-	@Override
-	public Param getGroupMember(int gi, int n) {
-		return null;
-	}
+	// @Override
+	// public Param getGroupMember(int gi, int n) {
+	//	return null;
+	// }
 
 	@Override
@@ -81,3 +83,13 @@
 	}
 
+	@Override
+	public Object call(String id, Object[] arguments) {
+		throw new InvalidOperationException().msg("list access does not support calling methods").arg("id", id);
+	}
+
+	@Override
+	public Object call(ProcedureParam param, Object[] arguments) {
+		throw new InvalidOperationException().msg("list access does not support calling methods").arg("param", param);
+	}
+
 };
Index: /java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Param.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/Param.java	(revision 90)
@@ -23,11 +23,4 @@
 	protected final String id;
 
-	//TODO
-	/**
-	 * The parameter internal id. It's set by a user to use user's own getId in
-	 * code
-	 */
-	protected final String internalId;
-
 	/** The parameter name. */
 	protected final String name;
@@ -48,5 +41,4 @@
 	public Param(ParamBuilder builder) {
 		id = builder.getId();
-		internalId = builder.getInternalId();
 		name = builder.getName();
 		help = builder.getHelp();
@@ -59,8 +51,4 @@
 	public String getId() {
 		return id;
-	}
-
-	public String getInternalId() {
-		return internalId;
 	}
 
@@ -87,10 +75,5 @@
 	public abstract String getFramsTypeName();
 
-
-	public String getEffectiveId() {
-		return (internalId != null) ? internalId : id;
-	}
-
-
+	@ParamAnnotation
 	public Integer getExtra() {
 		return extra;
Index: /java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 90)
@@ -11,6 +11,11 @@
 
 import java.lang.reflect.InvocationTargetException;
+import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.List;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+import javax.annotation.Nonnull;
 
 /**
@@ -37,12 +42,6 @@
 	private String id;
 
-	/**
-	 * The parameter internal id. It's set by a user to use user's own id in
-	 * code
-	 */
-	private String internalId;
-
 	/** The number of group, that parameter belongs to. */
-	private Integer group = 0;
+	private Integer group;
 
 	/** The flags stored as a bit sum. */
@@ -76,4 +75,7 @@
 	}
 
+	protected ValueParam resultType;
+
+	protected List<ValueParam> argumentsType;
 
 	/**
@@ -114,4 +116,36 @@
 
 	/**
+	 * @return the resultType
+	 */
+	public ValueParam getResultType() {
+		return resultType;
+	}
+
+
+	/**
+	 * @param resultType the resultType to set
+	 */
+	public ParamBuilder resultType(ValueParam resultType) {
+		this.resultType = resultType;
+		return this;
+	}
+
+	/**
+	 * @return the argumentsType
+	 */
+	public List<ValueParam> getArgumentsType() {
+		return argumentsType;
+	}
+
+
+	/**
+	 * @param argumentsType the argumentsType to set
+	 */
+	public ParamBuilder argumentsType(List<ValueParam> argumentsType) {
+		this.argumentsType = argumentsType;
+		return this;
+	}
+
+	/**
 	 * @return the enumValues
 	 */
@@ -121,15 +155,16 @@
 
 	/**
-	 * @return the procedureSignature
-	 */
-	public String getProcedureSignature() {
-		return procedureSignature;
-	}
-
-	/**
 	 * @return the uid
 	 */
 	public String getUid() {
 		return uid;
+	}
+
+	public @Nonnull <T extends Param> T finish(Class<T> requested) {
+		Param param = finish();
+		if (!requested.isInstance(param)) {
+			throw new FramsticksException().msg("param is of wrong type").arg("requested", requested).arg("actual", param.getClass());
+		}
+		return requested.cast(param);
 	}
 
@@ -141,10 +176,9 @@
 	 *             when Param getType is not defined
 	 */
-	public Param finish() {
+	public @Nonnull Param finish() {
 		try {
 			if (paramType == null) {
 				throw new FramsticksException().msg("trying to finish incomplete param");
 			}
-
 			return paramType.getConstructor(ParamBuilder.class).newInstance(this);
 		} catch (InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException | FramsticksException e) {
@@ -165,9 +199,4 @@
 	}
 
-	// public <T extends Param> ParamBuilder type(T param) {
-	//	return internalSetType(param.getClass(), param);
-	// }
-
-
 	/**
 	 * @return the id
@@ -178,16 +207,4 @@
 	}
 
-	/**
-	 * @return the internalId
-	 */
-	public String getInternalId() {
-		return internalId;
-	}
-
-	public ParamBuilder setInternalId(String internalId) {
-		this.internalId = internalId;
-		return this;
-	}
-
 	@ParamAnnotation
 	public ParamBuilder group(Integer group) {
@@ -208,5 +225,5 @@
 	}
 
-	protected <T extends Number> void parseMinMaxDefNumber(Class<T> type, String second, String third) {
+	protected <T extends Number> void parseMinMaxDefNumber(Class<T> type, String second, String third, String fourth) {
 		if (second != null) {
 			min = second;
@@ -214,4 +231,7 @@
 		if (third != null) {
 			max = third;
+		}
+		if (fourth != null) {
+			def = fourth;
 		}
 	}
@@ -223,6 +243,4 @@
 		return type(EnumParam.class);
 	}
-
-	protected String procedureSignature;
 
 	protected String uid;
@@ -239,4 +257,5 @@
 		String second = typeSplitted.length > 1 ? typeSplitted[1] : null;
 		String third = typeSplitted.length > 2 ? typeSplitted[2] : null;
+		String fourth = typeSplitted.length > 3 ? typeSplitted[3] : null;
 
 		switch (first.charAt(0)) {
@@ -247,6 +266,6 @@
 			}
 			case 'p': {
-				procedureSignature = type.substring(1);
 				type(ProcedureParam.class);
+				signature(type.substring(1));
 				break;
 			}
@@ -281,5 +300,5 @@
 				}
 				if (DecimalParam.class.isAssignableFrom(this.paramType)) {
-					parseMinMaxDefNumber(Integer.class, second, third);
+					parseMinMaxDefNumber(Integer.class, second, third, fourth);
 				}
 				break;
@@ -287,5 +306,5 @@
 			case 'f': {
 				type(FloatParam.class);
-				parseMinMaxDefNumber(Double.class, second, third);
+				parseMinMaxDefNumber(Double.class, second, third, fourth);
 				break;
 			}
@@ -472,8 +491,59 @@
 	}
 
-
 	public Class<?> getStorageType() {
 		return storageType;
 	}
+
+	public ParamBuilder forAccess(AccessInterface access) {
+		return name(access.getId()).type("o " + access.getId());
+	}
+
+	protected static ValueParam parseProcedureTypePart(String type, String name) {
+		return Param.build().type(type).name(name).id(name).finish(ValueParam.class);
+	}
+
+	private static Pattern addressPattern = Pattern.compile("^([^\\(]+)?\\(([^\\)]*)\\)$");
+
+	public ParamBuilder signature(String signature) {
+		argumentsType = new ArrayList<>();
+
+		if (!Strings.notEmpty(signature)) {
+			resultType = null;
+			return this;
+		}
+		Matcher matcher = addressPattern.matcher(signature);
+		if (!matcher.matches()) {
+			throw new FramsticksException().msg("invalid signature");
+		}
+		String result = Strings.collapse(matcher.group(1));
+		resultType = (result != null) ? parseProcedureTypePart(result, null) : null;
+		String arguments = matcher.group(2);
+		if (!Strings.notEmpty(arguments)) {
+			return this;
+		}
+		int number = 0;
+		for (String a : arguments.split(",")) {
+			int space = a.indexOf(' ');
+			String type;
+			String name;
+			if (space == -1) {
+				type = a;
+				name = "arg" + number;
+			} else {
+				type = a.substring(0, space);
+				name = a.substring(space + 1);
+			}
+			argumentsType.add(parseProcedureTypePart(type, name));
+			++number;
+		}
+		return this;
+	}
+
+
+	public ParamBuilder idAndName(String name) {
+		id(name);
+		name(name);
+		return this;
+	}
 }
 
Index: /java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 90)
@@ -10,9 +10,16 @@
 import java.lang.reflect.ParameterizedType;
 import java.lang.reflect.Type;
+import java.util.Arrays;
 import java.util.Collection;
+import java.util.Collections;
+import java.util.Comparator;
 import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
 import java.util.Map;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.ProcedureParam;
 
 public class ParamCandidate {
@@ -65,4 +72,7 @@
 	protected final OneTime<Method> setter = new OneTime<>("setter");
 	protected final OneTime<Method> getter = new OneTime<>("getter");
+	protected final OneTime<Method> caller = new OneTime<>("caller");
+
+	protected final List<ParamAnnotation> annotations = new LinkedList<>();
 
 	/**
@@ -124,6 +134,29 @@
 	}
 
+	/**
+	 * @return the getter
+	 */
+	public Method getCaller() {
+		return caller.get();
+	}
+
+	/**
+	 * @return the annotations
+	 */
+	public List<ParamAnnotation> getAnnotations() {
+		return Collections.unmodifiableList(annotations);
+	}
+
 	void validate() throws ConstructionException {
 		try {
+			if (caller.has()) {
+				if (!isPublic(caller)) {
+					throw new ConstructionException().msg("method is not public");
+				}
+				if (getter.has() || setter.has()) {
+					throw new ConstructionException().msg("getter or setter coexist with caller");
+				}
+				return;
+			}
 			if (isPublic(field)) {
 				if (getter.has()) {
@@ -147,4 +180,7 @@
 
 	boolean isFinal() {
+		if (caller.has()) {
+			return false;
+		}
 		if (Collection.class.isAssignableFrom(getRawType())) {
 			return false;
@@ -160,4 +196,7 @@
 
 	boolean isReadOnly() {
+		if (caller.has()) {
+			return false;
+		}
 		if (Collection.class.isAssignableFrom(getRawType())) {
 			return false;
@@ -172,8 +211,9 @@
 	}
 
-	void add(Member member, String name) {
+	void add(ParamAnnotation paramAnnotation, Member member, String name) {
 		this.name.set(name);
+		annotations.add(paramAnnotation);
 		if (member instanceof Field) {
-			this.field.set((Field) member);
+			field.set((Field) member);
 			setType(field.get().getGenericType());
 			return;
@@ -181,4 +221,11 @@
 		if (member instanceof Method) {
 			Method m = (Method) member;
+			if (!paramAnnotation.paramType().equals(Param.class)) {
+				if (paramAnnotation.paramType().equals(ProcedureParam.class)) {
+					caller.set(m);
+					return;
+				}
+				throw new ConstructionException().msg("explicit set of paramType different than ProcedureParam is not yet supported").arg("name", name).arg("method", m).arg("in", this);
+			}
 			Type[] ps = m.getGenericParameterTypes();
 			if (ps.length == 0) {
@@ -222,5 +269,5 @@
 	}
 
-	public static <M extends Member & AnnotatedElement> void filterParamsCandidates(Map<String, ParamCandidate> params, M[] members) {
+	public static <M extends Member & AnnotatedElement> void filterParamsCandidates(Set set, M[] members) {
 		for (M m : members) {
 			ParamAnnotation pa = m.getAnnotation(ParamAnnotation.class);
@@ -228,38 +275,89 @@
 				continue;
 			}
-			// if (!isPublic(m)) {
-			// 	throw new ConstructionException().msg("field is not public").arg("field", m);
-			// }
 			String id = FramsClassBuilder.getId(pa, m);
 			ParamCandidate pc = null;
-			if (params.containsKey(id)) {
-				pc = params.get(id);
+			if (set.getCandidates().containsKey(id)) {
+				pc = set.getCandidates().get(id);
 			} else {
 				pc = new ParamCandidate(id);
-				params.put(id, pc);
-			}
-			pc.add(m, FramsClassBuilder.getName(pa, m));
-
-		}
-	}
-
-	public static Map<String, ParamCandidate> getAllCandidates(Class<?> javaClass) throws ConstructionException {
-		Map<String, ParamCandidate> candidates = new HashMap<>();
-
+				set.getCandidates().put(id, pc);
+				set.getOrder().add(pc);
+			}
+			pc.add(pa, m, FramsClassBuilder.getName(pa, m));
+		}
+	}
+
+	public static class Set {
+		protected final Map<String, ParamCandidate> candidates;
+		protected final List<ParamCandidate> order;
+
+		/**
+		 * @param candidates
+		 * @param order
+		 */
+		public Set(Map<String, ParamCandidate> candidates, List<ParamCandidate> order) {
+			this.candidates = candidates;
+			this.order = order;
+		}
+
+		/**
+		 * @return the candidates
+		 */
+		public Map<String, ParamCandidate> getCandidates() {
+			return candidates;
+		}
+
+		/**
+		 * @return the order
+		 */
+		public List<ParamCandidate> getOrder() {
+			return order;
+		}
+	}
+
+	public static Set getAllCandidates(Class<?> javaClass) throws ConstructionException {
+
+		List<Class<?>> javaClasses = new LinkedList<>();
 		while (javaClass != null) {
-			filterParamsCandidates(candidates, javaClass.getDeclaredFields());
-			filterParamsCandidates(candidates, javaClass.getDeclaredMethods());
-
+			javaClasses.add(0, javaClass);
 			javaClass = javaClass.getSuperclass();
 		}
 
-		for (ParamCandidate pc : candidates.values()) {
+		Set resultSet = new Set(new HashMap<String, ParamCandidate>(), new LinkedList<ParamCandidate>());
+
+		for (Class<?> j : javaClasses) {
+			Set set = new Set(resultSet.getCandidates(), new LinkedList<ParamCandidate>());
+			filterParamsCandidates(set, j.getDeclaredFields());
+			filterParamsCandidates(set, j.getDeclaredMethods());
+
+			FramsClassAnnotation fa = j.getAnnotation(FramsClassAnnotation.class);
+			if (fa != null) {
+				final List<String> order = Arrays.asList(fa.order());
+				Collections.sort(set.getOrder(), new Comparator<ParamCandidate>() {
+					@Override
+					public int compare(ParamCandidate pc0, ParamCandidate pc1) {
+						int u0 = order.indexOf(pc0.getId());
+						int u1 = order.indexOf(pc1.getId());
+						if (u0 == -1 || u1 == -1) {
+							return 0;
+						}
+						return u0 - u1;
+					}
+				});
+			}
+			resultSet.getOrder().addAll(0, set.getOrder());
+		}
+
+		for (ParamCandidate pc : resultSet.getOrder()) {
 			pc.validate();
 		}
 
-		return candidates;
+		return resultSet;
 	}
 
 	public static Class<?> getRawClass(final Type type) {
+		if (type == null) {
+			throw new IllegalArgumentException();
+		}
 		if (Class.class.isInstance(type)) {
 			return Class.class.cast(type);
Index: /java/main/src/main/java/com/framsticks/params/ParamsPackage.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamsPackage.java	(revision 90)
+++ /java/main/src/main/java/com/framsticks/params/ParamsPackage.java	(revision 90)
@@ -0,0 +1,38 @@
+package com.framsticks.params;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public abstract class ParamsPackage {
+
+
+	protected boolean build = false;
+
+	public abstract void register(Registry registry);
+
+	/**
+	 * @return the build
+	 */
+	@ParamAnnotation
+	public boolean getBuild() {
+		return build;
+	}
+
+	/**
+	 * @param build the build to set
+	 */
+	@ParamAnnotation
+	public void setBuild(boolean build) {
+		this.build = build;
+	}
+
+	protected void register(Registry registry, Class<?> javaClass) {
+		if (build) {
+			registry.registerAndBuild(javaClass);
+		} else {
+			registry.register(javaClass);
+		}
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 90)
@@ -3,4 +3,6 @@
 import java.util.HashMap;
 import java.util.Map;
+
+import com.framsticks.params.types.ProcedureParam;
 
 
@@ -93,3 +95,13 @@
 	}
 
+	@Override
+	public Object call(String id, Object[] arguments) {
+		throw new InvalidOperationException().msg("list access does not support calling methods").arg("id", id);
+	}
+
+	@Override
+	public Object call(ProcedureParam param, Object[] arguments) {
+		throw new InvalidOperationException().msg("list access does not support calling methods").arg("param", param);
+	}
+
 }
